# -*- coding: utf-8 -*-
import sys
from PyQt5.QtWidgets import *
from PyQt5 import uic, QtWidgets
import os
from PyQt5.QtGui import *
import zipfile

form_class = uic.loadUiType("compressUncompress.ui")[0]

class MyWindow(QMainWindow, form_class):
    def __init__(self):
        super().__init__()

        self.setFixedSize(800,600)
        self.setWindowIcon(QIcon("pagichacha.png"))
        self.setupUi(self)

        self.pushButton.clicked.connect(self.startCompress)
        self.toolButton.clicked.connect(self.selectFiles)

        self.pushButton_3.clicked.connect(self.startUncompress)
        self.toolButton_3.clicked.connect(self.selectFile)

    def startUncompress(self):
        dir = os.path.dirname(file[0])
        os.chdir(dir)

        if self.lineEdit_4.text():
            uncomFileName = self.lineEdit_4.text()
            try:
                pass
                with zipfile.ZipFile(uncomFileName, 'r') as existing_zip:
                    existing_zip.extractall('.')
                self.textEdit.setText("선택하신 압축 파일 ("+str(uncomFileName)+") 이 정상적으로 해당 폴더 (현재폴더) 에 압축 해제 되었습니다.")
            except:
                pass
                self.textEdit.setText("압축 해제과정에서 에러가 발생하였습니다.")
        else:
            self.textEdit.setText("압축 해제할 파일을 선택하지 않았습니다.")

    def startCompress(self):
        if len(files[0]) == 1:
            files2 = files[0][0]
            file = os.path.basename(files2)
            dir = os.path.dirname(files2)
            os.chdir(dir)

            if self.lineEdit.text() and self.lineEdit_2.text():
                comFileName = self.lineEdit.text()
                try:
                    pass
                    new_zip = zipfile.ZipFile(comFileName, 'w')
                    new_zip.write(file, compress_type=zipfile.ZIP_DEFLATED)
                    self.textEdit.setText("선택하신 파일 ("+file+") 이 정상적으로 해당 폴더 ("+dir+") 에 압축("+comFileName+")되었습니다.")
                    new_zip.close()
                except:
                    pass
                    self.textEdit.setText("압축 실행과정에서 에러가 발생하였습니다.")
            else:
                self.textEdit.setText("압축할 파일을 선택하지 않았거나, 압축할 파일명을 입력하지 않았습니다.")
        else:
            myfiles = []

            for file in files[0]:
                myfiles.append(os.path.basename(file))

            files2 = files[0][0]
            dir = os.path.dirname(files2)
            os.chdir(dir)

            if self.lineEdit.text() and self.lineEdit_2.text():
                comFileName = self.lineEdit.text()
                try:
                    with zipfile.ZipFile(comFileName, 'w') as my_zip:
                        for file in myfiles:
                            my_zip.write(file)
                        my_zip.close()
                    self.textEdit.setText("선택하신 파일 ("+str(myfiles)+") 이 정상적으로 해당 폴더 ("+dir+") 에 압축("+comFileName+")되었습니다.")
                except:
                    self.textEdit.setText("압축 실행과정에서 에러가 발생하였습니다.")
            else:
                self.textEdit.setText("압축할 파일을 선택하지 않았거나, 압축할 파일명을 입력하지 않았습니다.")

    def selectFiles(self):
        global files
        files = QtWidgets.QFileDialog.getOpenFileNames()
        self.lineEdit_2.setText('{}'.format(files[0]))

    def selectFile(self):
        global file
        file = QtWidgets.QFileDialog.getOpenFileName()
        self.lineEdit_4.setText('{}'.format(file[0]))

app=QApplication(sys.argv)
window = MyWindow()
window.show()
app.exec_()
